Skip to content

# Merge

The tool to check the availability or syntax of domain, IP or URL.

::

    ██████╗ ██╗   ██╗███████╗██╗   ██╗███╗   ██╗ ██████╗███████╗██████╗ ██╗     ███████╗
    ██╔══██╗╚██╗ ██╔╝██╔════╝██║   ██║████╗  ██║██╔════╝██╔════╝██╔══██╗██║     ██╔════╝
    ██████╔╝ ╚████╔╝ █████╗  ██║   ██║██╔██╗ ██║██║     █████╗  ██████╔╝██║     █████╗
    ██╔═══╝   ╚██╔╝  ██╔══╝  ██║   ██║██║╚██╗██║██║     ██╔══╝  ██╔══██╗██║     ██╔══╝
    ██║        ██║   ██║     ╚██████╔╝██║ ╚████║╚██████╗███████╗██████╔╝███████╗███████╗
    ╚═╝        ╚═╝   ╚═╝      ╚═════╝ ╚═╝  ╚═══╝ ╚═════╝╚══════╝╚═════╝ ╚══════╝╚══════╝

Provides the merging helpers.

Author: Nissar Chababy, @funilrys, contactTATAfunilrysTODTODcom

Special thanks: https://pyfunceble.github.io/#/special-thanks

Contributors: https://pyfunceble.github.io/#/contributors

Project link: https://github.com/funilrys/PyFunceble

Project documentation: https://docs.pyfunceble.com

Project homepage: https://pyfunceble.github.io/

License: ::

    Copyright 2017, 2018, 2019, 2020, 2022, 2023, 2024, 2025 Nissar Chababy

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        https://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

## `Merge`

Simplify the merging of dict and list.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`subject` | `Optional[Any]` | The subject to work with. | `None`

Source code in `PyFunceble/helpers/merge.py`

     57
     58
     59
     60
     61
     62
     63
     64
     65
     66
     67
     68
     69
     70
     71
     72
     73
     74
     75
     76
     77
     78
     79
     80
     81
     82
     83
     84
     85
     86
     87
     88
     89
     90
     91
     92
     93
     94
     95
     96
     97
     98
     99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182

    class Merge:
        """
        Simplify the merging of dict and list.

        :param subject:
            The subject to work with.
        """

        _subject: Optional[Any] = None

        def __init__(self, subject: Optional[Any] = None):
            if subject is not None:
                self.subject = subject

        @property
        def subject(self) -> Optional[Any]:
            """
            Provides the current state of the :code:`_subject` attribute.
            """

            return self._subject

        @subject.setter
        def subject(self, value: Any) -> None:
            """
            Sets the subject to work with.

            :param value:
                The subject to work with.

            :raise TypeError:
                When :code:`value` is not a :py:class:`list`.
            """

            self._subject = copy.deepcopy(value)

        def set_subject(self, value: Any) -> "Merge":
            """
            Sets the subject to work with.

            :param value:
                The subject to work with.

            :raise TypeError:
                When :code:`value` is not a :py:class:`list`.
            """

            self.subject = value

            return self

        def __list(self, origin: Any, strict: bool = True) -> List[Any]:
            """
            Process the list merging.

            :param strict:
                Activates the strict mode.
            """

            result = []

            if strict:
                for index, element in enumerate(self.subject):
                    try:
                        if isinstance(element, dict) and isinstance(origin[index], dict):
                            result.append(Merge(element).into(origin[index], strict=strict))
                        elif isinstance(element, list) and isinstance(origin[index], list):
                            result.append(Merge(element).into(origin[index], strict=strict))
                        else:
                            result.append(element)
                    except IndexError:  # pragma: no cover ## Safety
                        result.append(element)
            else:
                result = origin

                for element in self.subject:
                    if element not in result:
                        result.append(element)

            return result

        def __dict(self, origin: Any, strict: bool = True) -> dict:
            """
            Process the dict merging.

            :param bool strict:
                Activates the strict mode.
            """

            result = {}

            for index, data in self.subject.items():
                if index in origin:
                    if isinstance(data, dict) and isinstance(origin[index], dict):
                        result[index] = Merge(data).into(origin[index], strict=strict)
                    elif isinstance(data, list) and isinstance(origin[index], list):
                        result[index] = Merge(data).into(origin[index], strict=strict)
                    else:
                        result[index] = data
                else:
                    result[index] = data

            for index, data in origin.items():
                if index not in result:
                    result[index] = data

            return result

        def into(self, origin: Any, strict: bool = True) -> Any:
            """
            Process the merging.

            :param origin: The original data.
            :param strict:
                Activates the strict mode.
            """

            origin = copy.deepcopy(origin)

            if isinstance(self.subject, list) and isinstance(origin, list):
                return self.__list(origin, strict=strict)

            if isinstance(self.subject, dict) and isinstance(origin, dict):
                return self.__dict(origin, strict=strict)

            return self.subject

### `subject` `property` `writable`

Provides the current state of the :code:`_subject` attribute.

### `__dict(origin, strict=True)`

Process the dict merging.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`strict` | `bool` | Activates the strict mode. | `True`

Source code in `PyFunceble/helpers/merge.py`

    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163

    def __dict(self, origin: Any, strict: bool = True) -> dict:
        """
        Process the dict merging.

        :param bool strict:
            Activates the strict mode.
        """

        result = {}

        for index, data in self.subject.items():
            if index in origin:
                if isinstance(data, dict) and isinstance(origin[index], dict):
                    result[index] = Merge(data).into(origin[index], strict=strict)
                elif isinstance(data, list) and isinstance(origin[index], list):
                    result[index] = Merge(data).into(origin[index], strict=strict)
                else:
                    result[index] = data
            else:
                result[index] = data

        for index, data in origin.items():
            if index not in result:
                result[index] = data

        return result

### `__list(origin, strict=True)`

Process the list merging.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`strict` | `bool` | Activates the strict mode. | `True`

Source code in `PyFunceble/helpers/merge.py`

    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136

    def __list(self, origin: Any, strict: bool = True) -> List[Any]:
        """
        Process the list merging.

        :param strict:
            Activates the strict mode.
        """

        result = []

        if strict:
            for index, element in enumerate(self.subject):
                try:
                    if isinstance(element, dict) and isinstance(origin[index], dict):
                        result.append(Merge(element).into(origin[index], strict=strict))
                    elif isinstance(element, list) and isinstance(origin[index], list):
                        result.append(Merge(element).into(origin[index], strict=strict))
                    else:
                        result.append(element)
                except IndexError:  # pragma: no cover ## Safety
                    result.append(element)
        else:
            result = origin

            for element in self.subject:
                if element not in result:
                    result.append(element)

        return result

### `into(origin, strict=True)`

Process the merging.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`origin` | `Any` | The original data. | required
`strict` | `bool` | Activates the strict mode. | `True`

Source code in `PyFunceble/helpers/merge.py`

    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182

    def into(self, origin: Any, strict: bool = True) -> Any:
        """
        Process the merging.

        :param origin: The original data.
        :param strict:
            Activates the strict mode.
        """

        origin = copy.deepcopy(origin)

        if isinstance(self.subject, list) and isinstance(origin, list):
            return self.__list(origin, strict=strict)

        if isinstance(self.subject, dict) and isinstance(origin, dict):
            return self.__dict(origin, strict=strict)

        return self.subject

### `set_subject(value)`

Sets the subject to work with.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`value` | `Any` | The subject to work with. | required

Raises:

Type | Description
--- | ---
`TypeError` | When :code:`value` is not a class:`list`.

Source code in `PyFunceble/helpers/merge.py`

     93
     94
     95
     96
     97
     98
     99
    100
    101
    102
    103
    104
    105
    106

    def set_subject(self, value: Any) -> "Merge":
        """
        Sets the subject to work with.

        :param value:
            The subject to work with.

        :raise TypeError:
            When :code:`value` is not a :py:class:`list`.
        """

        self.subject = value

        return self